<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">

<head>
	<title>Modbus Driver setup page</title>

	<link rel='stylesheet' type="text/css" href='../css/meti_merged.css'>

	<script src='../js/meti_merged_dt.js'></script>
	<script src='../js/meti_utils.js'></script>

	<style>
		#main_body {
			visibility: hidden;
		}

		.dd-item {
			padding: 0.1rem 0.25rem;
			cursor: pointer;
		}

		.label_title {
			/* font-weight: bold; */
			color: #007bff;
		}

		#button_driver_save {
			font-size: xx-small;
			display: none;
		}

		/* .table th {
			white-space: nowrap;
			width: 1%;
		} */

		.table td {
			white-space: nowrap;
			width: 1%;
			padding-top: 2px;
			padding-bottom: 2px;
		}

		.delete_class {
			cursor: pointer;
		}

		.active_click {
			cursor: pointer;
		}

		.driver_table_div {
			font-size: smaller;
		}
	</style>

</head>

<body>
	<div id="main_body">
		<div w3-include-html="meti_bst.html"></div>

		<div class="container m-1">
			<div class="row">
				<main role="main" class="col-md-12 m-1">
					<div class="col-sm-12 row border border-primary rounded">
						<div class="col-sm-12 row">
							<div class="col-sm-3 p-1">
								<div class="row">
									<label class="label_title m-1" for="sel_vendor">Vendors</label>
									<div id="loader_vendor" class="meti_loader m-1" style="width:1.5rem; height:1.5rem">
									</div>
								</div>
								<select class="row form-control form-control-sm" id="sel_vendor" name="sel_vendor"
									size="5"></select>
							</div>
							<div class="col-sm-3 p-1">
								<div class="row">
									<label class="label_title m-1" for="sel_device">Devices</label>
									<!-- <div id="loader_device" class="meti_loader m-1" style="width:1.5rem; height:1.5rem"></div> -->
								</div>
								<select class="row form-control form-control-sm" id="sel_device" name="sel_device"
									size="5"></select>
							</div>
							<div class="col-sm-3 p-1">
								<div class="row">
									<label class="label_title m-1" for="sel_driver">Available drivers</label>
									<div id="loader_driver" class="meti_loader m-1" style="width:1.5rem; height:1.5rem">
									</div>
								</div>
								<select class="row form-control form-control-sm" id="sel_driver" name="sel_driver"
									size="5"></select>
							</div>
							<div class="col-sm-3 p-1">
								<div class="row">
									<label class="label_title m-1" for="sel_param">Parameters</label>
									<button type="button" id="button_driver_save"
										class="btn btn-xs btn-warning p-1 m-1">Save
										driver to device</button>
									<div id="loader_param" class="meti_loader m-1" style="width:1.5rem; height:1.5rem">
									</div>
								</div>
								<select class="row form-control form-control-sm" id="sel_param" name="sel_param"
									size="5"></select>
							</div>
						</div>
					</div>

					<div class="col-sm-12 row border border-primary rounded">
						<div class="col-sm-12 p-0">
							<div class="row ml-1 mr-1">
								<label class="label_title m-1">Modbus drivers used in device</label>
								<button type="button" id="button_driver_configure"
									class="btn btn-xs btn-danger p-1 m-1">Configure</button>
								<div id="loader_driver_list" class="meti_loader m-1"
									style="width:1.5rem; height:1.5rem">
								</div>
							</div>

							<div class="row ml-1 mr-1 driver_table_div">
								<table id="driver_table" class="table table-primary table-striped table-hover">
									<thead>
										<tr>
											<th scope="col">Sl.</th>
											<th scope="col">Vendor</th>
											<th scope="col">Device</th>
											<th scope="col">Driver Name</th>
											<th scope="col">Start addr</th>
											<th scope="col">Reg count</th>
											<th scope="col">Delete</th>
										</tr>
									</thead>
									<tbody id="driver_table_body" class="driver_table_data_class">
										<!-- Driver list comes here... -->
									</tbody>
								</table>
							</div>
						</div>
					</div>
				</main>
			</div>
		</div>
	</div>
</body>
</html>


<script>
	w3IncludeHTML();
	var g_currentDriver = {};

	$(document).ready(function () {
		$("#main_body").css("visibility", "visible");
		var g_vendorsAndMeters = {};

		$("#button_driver_save").on("click", function () {
			param = $("#sel_param").html();
			if (param != '') {
				saveDriver();
			} else {
				alert("Nothing to save....\n\nPlease Select Vendor->Device->Available Driver first..");
			}
		});

		function getVendorsAndMeters() {
			var url = "https://test.meti.in/test/index.php/quickiot/get_driver_list";
			if (LOCAL_HOST == true) {
				url = "http://localhost/play/index.php/quickiot/get_driver_list";
			}

			var type = 'POST';
			var data = {
				// Narayan this has to be actual deice ID
				device_id: g_device_id,
				api_key: "4d5302f9e0c38f076673e62096db3a4a",
				app_key: "quickIoT"
			};

			$("#loader_vendor").css("display", "block");

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (responseText) {
					$("#loader_vendor").css("display", "none");
					response = JSON.parse(responseText)

					var result = response.result;
					if (result == 1) {
						g_vendorsAndMeters = response.template_headers;
						updateVendors();
					}
					else if (result == 0) {
						console.log(response.message);
					}
				},
				error: function (jqXHR, exception, response) {
					$("#loader_vendor").css("display", "none");
					alert('POST Error!! Unable to get Vendors Devices...');
				}
			});
		}

		function getDriver(driver_id) {
			g_currentDriver = '';
			var url = "https://test.meti.in/test/index.php/quickiot/get_driver";
			if (LOCAL_HOST == true) {
				url = "http://localhost/play/index.php/quickiot/get_driver";
			}

			var type = 'POST';
			var data = {
				app_key: "quickIoT",
				api_key: "4d5302f9e0c38f076673e62096db3a4a",
				driver_id: driver_id,
				driver_version: "1",
				// Narayan this has to be actual device id
				device_id: g_device_id,
			};

			$("#loader_driver").css("display", "block");

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (responseText) {
					$("#loader_driver").css("display", "none");
					response = JSON.parse(responseText)
					// console.log(response);

					var result = response.result;
					if (result == 1) {
						g_currentDriver = response.driver;
						updateParameters(response);
						$("#button_driver_save").css('display', 'block');
					}
					else if (result == 0) {
						console.log(response.message);
					}
				},
				error: function (jqXHR, exception, response) {
					$("#loader_driver").css("display", "none");
					alert('POST Error!! Unable to get selected driver...');
				}
			});
		}

		function saveDriver() {
			var driver_id = $("#sel_driver").val();

			var sensor_count = Object.keys(g_currentDriver.command.responseParser).length;
			if (sensor_count > 16) {
				alert("Drivers with a maximum of 16 sensors/parameters supported in this device...\n\nPlease contact vendor for higher version...")
				return;
			}

			g_currentDriver.active = false;
			var driver_file = JSON.stringify(g_currentDriver);

			var data = {};
			data["driver_id"] = driver_id;

			MAX_POST_SIZE = 1000;
			var fileSize = driver_file.length;
			ctr = 0;
			while (fileSize > 0) {
				start = ctr * MAX_POST_SIZE;
				end = start + MAX_POST_SIZE;
				data["driver_file" + ctr] = driver_file.substring(start, end);
				fileSize = fileSize - MAX_POST_SIZE;
				ctr++;
			}
			data['driver_chunks'] = ctr;
			data['fileSize'] = driver_file.length;

			var url = "/saveNewModbusDriver";
			if (LOCAL_HOST == true) {
				url = "http://localhost/play/index.php/quickiot_simulate/save_driver_to_device";
			}
			var type = 'POST';

			$("#loader_param").css("display", "block");

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (response) {
					$("#loader_param").css("display", "none");
					// response = JSON.parse(responseText)

					var result = response.result;
					if (result == 1) {
						listAllDriver();
						alert(response.message);
						// g_vendorsAndMeters = response.template_headers;
						// updateVendors();
					}
					else if (result == 0) {
						console.log(response.message);
					}
				},
				error: function (jqXHR, exception, response) {
					$("#loader_param").css("display", "none");
					alert('POST Error!! Unable to save driver');
				}
			});
		}

		function deleteDriver(driver_id) {
			var url = "/deleteModbusDriver";
			if (LOCAL_HOST == true) {
				url = "http://localhost/play/index.php/quickiot_simulate/delete_driver_from_device";
			}

			var type = 'POST';
			var data = {
				app_key: "quickIoT",
				driver_id: driver_id,
			};

			$("#loader_driver_list").css("display", "block");

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (response) {
					$("#loader_driver_list").css("display", "none");

					var result = response.result;
					if (result == 1) {
						listAllDriver();
						alert(response.message);
					}
					else if (result == 0) {
						console.log(response.message);
					}
				},
				error: function (jqXHR, exception, response) {
					$("#loader_driver_list").css("display", "none");
					alert('POST Error!! Unable to save driver');
				}
			});
		}

		function listAllDriver() {
			var url = "/getAllModbusDrivers"
			if (LOCAL_HOST == true) {
				url = "http://localhost/play/index.php/quickiot_simulate/list_drivers_from_device";
			}
			//Narayan - this will be from meti_api_server
			var type = 'POST';
			var data = {
				app_key: "quickIoT"
			};

			$("#loader_driver_list").css("display", "block");

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (response) {
					$("#loader_driver_list").css("display", "none");
					var result = response.result;
					if (result == 1) {
						updateDeviceDrivers(response);
					}
					else if (result == 0) {
						console.log(response.message);
					}
				},
				error: function (jqXHR, exception, response) {
					$("#loader_driver_list").css("display", "none");
					alert('POST Error!! Unable to get Driver list from device...');
				}
			});
		}

		function updateVendors() {
			var vendor_list = [];

			//get the vendor names
			$.each(g_vendorsAndMeters, function (idx, val) {
				var vendor_name = val.vendor_name
				if (vendor_list.indexOf(vendor_name) === -1) {
					vendor_list.push(vendor_name)
				}
			});

			// sort the array
			vendor_list.sort();

			$("#sel_vendor").html('');
			//include in the dropdown
			$.each(vendor_list, function (idx, val) {
				var opt = $('<option></option>')
					.val(val)
					.addClass('dropdown-item')
					.addClass('dd-item')
					.text(val);

				if (idx == 0) {
					opt.attr("selected", true);
				}

				$("#sel_vendor").append(opt);
			});

			updateDevices(vendor_list[0]);
		}

		function updateDevices(sel_vendor_name) {
			var device_list = [];

			//get the devices names of particular vendor
			$.each(g_vendorsAndMeters, function (idx, val) {
				if (val.vendor_name == sel_vendor_name) {
					var meter_name = val.meter_name;

					if (device_list.indexOf(meter_name) === -1) {
						device_list.push(meter_name)
					}
				}
			});

			// sort the device array
			device_list.sort();

			$("#sel_device").html('');
			//include in the dropdown
			$.each(device_list, function (idx, val) {
				var opt = $('<option></option>')
					.val(val)
					.addClass('dropdown-item')
					.addClass('dd-item')
					.text(val);

				$("#sel_device").append(opt);
			});
		}

		function updateDriverList(sel_vendor_name, sel_meter_name) {
			$("#sel_driver").html('');

			//get the devices names of particular vendor
			$.each(g_vendorsAndMeters, function (idx, val) {
				if (val.vendor_name == sel_vendor_name) {
					if (val.meter_name == sel_meter_name) {
						var opt = $('<option></option>')
							.val(val.template_id)
							.addClass('dropdown-item')
							.addClass('dd-item')
							.text(val.template_name);

						$("#sel_driver").append(opt);
					}
				}
			});
		}

		function updateParameters(response) {
			$("#sel_param").html('');

			//get the parameter/sensor names
			$.each(response.driver.command.responseParser, function (idx, val) {
				var opt = $('<option></option>')
					.val(val.id)
					.addClass('dropdown-item')
					.addClass('dd-item')
					.text(val.nm + "  (" + val.un + ")");

				$("#sel_param").append(opt);
			});
		}

		function updateDeviceDrivers(response) {
			table_clear('#driver_table');
			// table_destroy('#driver_table');
			new_table = [];
			$.each(response.driver_list, function (idx, val) {
				var row = [];
				row.push(idx + 1);
				row.push(val['vendor']);
				row.push(val['meter']);
				row.push(val['name']);
				row.push(val['startAddr']);
				row.push(val['regCount']);

				// params = val['params'];
				// if (params.length > 30) {
				// 	row.push(params.substr(0, 25) + ".....");
				// } else {
				// 	row.push(params);
				// }

				// active_str = "<a class='active_click'>" + val['active'] + " </a>"
				// row.push(active_str);

				del_str = "<img class='delete_class' "
					+ " data-driver_id='" + val['driver_id'] + "'"
					+ " data-driver_name='" + val['vendor'] + ' -> ' + val['meter'] + ' -> ' + val['name'] + "'"
					+ " src='../images/delete.ico' alt='Delete' "
					+ " width='24' height='24'>"
				row.push(del_str);

				new_table.push(row);
			});

			table_add_rows('#driver_table', new_table);

			// Link the listener for active click
			// $(".active_click").on("click", function () {
			// 	console.log($(this));
			// });

			// Link the listener for delete click
			$(".delete_class").on("click", function () {
				var driver_id = $(this).data("driver_id");
				var driver_name = $(this).data("driver_name");

				var r = confirm("Delete the driver from device?\n\n" + driver_name);
				if (r == true) {
					deleteDriver(driver_id);
				}
			});
		}

		function driver_list_table_init() {
			var order_by = [[1, "asc"], [2, "asc"], [3, "asc"]];

			$('#driver_table').removeAttr('hidden');

			driver_table = $('#driver_table').DataTable({
				"bSort": true,
				"order": order_by,
				"searching": false,
				"paging": false,
				"bInfo": false,
				"columnDefs": [
					{
						"targets": [0], //first column / numbering column
						"orderable": false, //set not orderable
					},
				]
			});

			driver_table.on('order.dt search.dt', function () {
				driver_table.column(0, { search: 'applied', order: 'applied' }).nodes().each(function (cell, i) {
					cell.innerHTML = i + 1;
				});
			}).draw();
		}

		$("#sel_vendor").on("change", function () {
			$("#sel_device").html('');
			$("#sel_driver").html('');
			$("#sel_param").html('');
			$("#button_driver_save").css('display', 'none');

			updateDevices($(this).val());
		});

		$("#sel_device").on("change", function () {
			$("#sel_driver").html('');
			$("#sel_param").html('');
			$("#button_driver_save").css('display', 'none');

			sel_vendor = $("#sel_vendor").val();
			if (g_device_id == '') {
				alert("Device Id issue.. Please reload page...");
			} else {
				updateDriverList(sel_vendor, $(this).val());
			}
		});

		$("#sel_driver").on("change", function () {
			$("#sel_param").html('');
			$("#button_driver_save").css('display', 'none');

			sel_driver = $("#sel_driver").val();
			getDriver(sel_driver);
		});

		$("#button_driver_configure").on("click", function () {
			window.location.href = "ModbusDriverConfig.html";
		});

		setTimeout(function () {
			getVendorsAndMeters();
		}, 750);

		setTimeout(function () {
			listAllDriver();
			driver_list_table_init();
		}, 1500);
		// $('#driver_table').DataTable();
	});
</script>